%define name    ka-run 
%define version 2.0
%define release 28mdk

Summary: 	A program to launch a command on several hosts
Name:		%{name}
Version: 	%{version}
Release: 	%{release}
License: 	GPL
Group: 		Networking/Remote access
Source: 	ka-run-2.0-3.tar.bz2
Source1:	mput
Source2:	mputn
Source3:	rshp
Source4:	rshpn
BuildRoot:	%{_tmppath}/%{name}-%{version}
URL:		http://sourceforge.net/projects/ka-tools/
BuildRequires:	glibc-static-devel, libstdc++-static-devel
Requires:	openssh-server
Patch1:		%{name}-define.patch.bz2
Patch2:		%{name}-pthread.patch.bz2
Patch3:		%{name}-gcc34.patch.bz2
Patch4:		%{name}-redir.patch.bz2
Patch5:		%{name}-gcc343.patch.bz2
Patch6:		ka-run-2.0-3-64bit-fixes.patch.bz2
%description
This program allows the user to launch the same command on several hosts.
The connection is made via rsh or ssh as the user wants.

%prep
%setup -q -n ka-run-2.0-3
%patch1
%patch2
%patch3
%patch4
%patch5 -p0
%patch6 -p1 -b .64bit-fixes

# manually update config.* scripts
for d in InukSpread Network Pthread; do
  rm -f $d/config.guess
  ln -s ../config.guess $d/config.guess
  rm -f $d/config.sub
  ln -s ../config.sub $d/config.sub
done
cp /usr/share/libtool/config.{sub,guess} .

%build
./configure --prefix=$RPM_BUILD_ROOT --with-cxx=g++ --with-cc=gcc --libdir=%{_libdir}

#Changing optimisations to -O1 (-O3 & -O2 generates some stranges behaviours)
grep -ril "\-O3" * | xargs perl -pi -e "s/\-O3/\-O1/g"
grep -ril "\-O2" * | xargs perl -pi -e "s/\-O2/\-O1/g"
MYCFLAGS=$(echo $RPM_OPT_FLAGS | sed -e 's/\-O2/\-O1/')

#Forcing to m32 to prevent mixing arch troubles
find -type f | xargs perl -pi -e "s| -shared | -shared -m32 |g" 
make prefix=$RPM_BUILD_ROOT OPT="$MYCFLAGS -m32"

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_bindir}
mkdir -p $RPM_BUILD_ROOT%{_bindir}/../core
mkdir -p $RPM_BUILD_ROOT%{_defaultdocdir}/%{name}/html
mkdir -p $RPM_BUILD_ROOT%{_mandir}/man1
install Ptools/src/pbash $RPM_BUILD_ROOT%{_bindir}/pbash
install Ptools/src/pcsh $RPM_BUILD_ROOT%{_bindir}/pcsh
install Ptools/src/ptcsh $RPM_BUILD_ROOT%{_bindir}/ptcsh
install -s -m 6755 InukSpread/bin/mput $RPM_BUILD_ROOT%{_bindir}/mput_wrap
install -s -m 6755 InukSpread/bin/rshp $RPM_BUILD_ROOT%{_bindir}/rshp_wrap
install -s -m 6755 InukSpread/bin/rshp_sync $RPM_BUILD_ROOT%{_bindir}/rshp_sync
install -s -m 755 InukSpread/bin/redir $RPM_BUILD_ROOT%{_bindir}/redir
install Ptools/src/genere_ptools $RPM_BUILD_ROOT%{_bindir}/genere_ptools
install Ptools/src/rm_ptools $RPM_BUILD_ROOT%{_bindir}/rm_ptools
install InukSpread/doc/html/rshp.html $RPM_BUILD_ROOT%{_defaultdocdir}/%{name}/html/rshp.html
install InukSpread/doc/html/mput.html $RPM_BUILD_ROOT%{_defaultdocdir}/%{name}/html/mput.html
install Ptools/html/ptools.html $RPM_BUILD_ROOT%{_defaultdocdir}/%{name}/html/ptools.html
install InukSpread/doc/man/man1/rshp.1  $RPM_BUILD_ROOT%{_mandir}/man1/rshp.1
install Ptools/man/man1/ptools.1  $RPM_BUILD_ROOT%{_mandir}/man1/ptools.1
install InukSpread/doc/man/man1/mput.1 $RPM_BUILD_ROOT%{_mandir}/man1/mput.1
install Ptools/man/man1/genere_ptools.1 $RPM_BUILD_ROOT%{_mandir}/man1/genere_ptools.1
install Ptools/man/man1/rm_ptools.1 $RPM_BUILD_ROOT%{_mandir}/man1/rm_ptools.1

perl -pi -e "s|$RPM_BUILD_ROOT|/usr|g" $RPM_BUILD_ROOT%{_bindir}/genere_ptools

install Ptools/man/man1/rm_ptools.1 $RPM_BUILD_ROOT%{_mandir}/man1/rm_ptools.1

# Installing wrappers
install -m 755 %{SOURCE1} %{buildroot}/%{_bindir}
install -m 755 %{SOURCE2} %{buildroot}/%{_bindir}
install -m 755 %{SOURCE3} %{buildroot}/%{_bindir}
install -m 755 %{SOURCE4} %{buildroot}/%{_bindir}

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%attr(755,root,root) %{_bindir}/rshp
%attr(755,root,root) %{_bindir}/rshpn
%attr(755,root,root) %{_bindir}/rshp_wrap
%attr(755,root,root) %{_bindir}/rshp_sync
%attr(755,root,root) %{_bindir}/mput
%attr(755,root,root) %{_bindir}/mput_wrap
%attr(755,root,root) %{_bindir}/mputn
%attr(755,root,root) %{_bindir}/redir
%attr(755,root,root) %{_bindir}/genere_ptools
%attr(755,root,root) %{_bindir}/rm_ptools
%attr(755,root,root) %{_bindir}/pbash
%attr(755,root,root) %{_bindir}/ptcsh 
%attr(755,root,root) %{_bindir}/pcsh 

%doc  %{_defaultdocdir}/%{name}/*
%{_mandir}/man1/*

%changelog
* Wed Sep  7 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.0-28mdk
- (some) 64-bit fixes
- fix buildrequires for gcc4

* Thu Feb 17 2005 Rafael Garcia-Suarez <rgarciasuarez@mandrakesoft.com> 2.0-27mdk
- Add patch 5, build with gcc 3.4.3

* Wed Feb 16 2005 Erwan Velu <erwan@seanodes.com> 2.0-26mdk
- Fixing multiple arch build
* Fri Nov 10 2004 Erwan Velu <erwan@mandrakesoft.com> 2.0-25mdk
- Fixing build
* Tue Jul 27 2004 Erwan Velu <erwan@mandrakesoft.com> 2.0-24mdk
- Removing Patch0
- Bzip2 patch3 
- Cleaning spec file
- Fixing rpmlint suggestions
* Tue Jul 27 2004 Erwan Velu <erwan@mandrakesoft.com> 2.0-23mdk
- Rebuild with gcc 3.4
- Patching Pthread call (missing _next definition) (patch 2)
- Patching left assignements (patch 3)
- gb rulez :) 
* Fri Apr 08 2004 Erwan Velu <erwan@mandrakesoft.com> 2.0-22mdk
- Adding rshp, rshpn, mput & mputn wrappers
* Wed Mar 24 2004 Erwan Velu <erwan@mandrakesoft.com> 2.0-21mdk
- Switching to -O1
* Wed Mar 24 2004 Erwan Velu <erwan@mandrakesoft.com> 2.0-20mdk
- Reverting old configure options

* Tue Mar 23 2004 Erwan Velu <erwan@mandrakesoft.com> 2.0-19mdk
- Fixing wrong "define barrier"

* Thu Jul 24 2003 Per yvind Karlsen <peroyvind@sintrax.net> 2.0-18mdk
- rebuild
- use %%make macro
- don't rm -rf $RPM_BUILD_ROOT in %%prep
- use %%configure macro in %%build, don't do configure in %%prep

* Thu Jan 16 2003 Erwan Velu <erwan@mandrakesoft.com> 2.0-17mdk
- Glibc rebuild
- Fixing missing documentation
* Tue Oct 08 2002 Clic-dev <clic-dev-public@mandrakesoft.com> 2.0-16mdk
- Fixing buildrequires

* Wed Sep 11 2002 Erwan Velu <erwan@mandrakesoft.com> 2.0-15mdk
- Re-enabling O3 option
- Adding new version of mput (Thx to wilfrid)

* Wed Sep 11 2002 Erwan Velu <erwan@mandrakesoft.com> 2.0-14mdk
- Fixing compiling options (removing -O3)

* Mon Sep 10 2002 Erwan Velu <erwan@mandrakesoft.com> 2.0-13mdk
- Cleaning c++ code

* Mon Sep 09 2002 Erwan Velu <erwan@mandrakesoft.com> 2.0-12mdk
- New version of mput (accepting multiple cp for a session)

* Fri Sep 07 2002 Erwan Velu <erwan@mandrakesoft.com> 2.0-11mdk
- Removing bashrc entries (Thx to Fred)
- Setting SPREAD_REDIR to /usr/bin
- Fixing perl regexp
* Fri Sep 07 2002 Erwan Velu <erwan@mandrakesoft.com> 2.0-10mdk
- Removing debugging mode

* Fri Sep 07 2002 Erwan Velu <erwan@mandrakesoft.com> 2.0-9mdk
- Adding missing environment variable in /etc/bashrc
- Removing old patches

* Fri Sep 06 2002 Erwan Velu <erwan@mandrakesoft.com> 2.0-8mdk
- Moving to 2.0-3
- Changing tree

* Mon Aug 26 2002 Erwan Velu <erwan@mandrakesoft.com> 2.0-7mdk
- Removing setuid and getuid bits to avoid security flaws

* Wed Aug 21 2002 Frederic Lepied <flepied@mandrakesoft.com> 2.0-6mdk
- bziped source
- merged the 3 patches in one
- use %%make
- compile with gcc 3.2 and optimization
- use ssh by default instead of rsh and depends on openssh-server btw instead of rsh-server
- removed lsnodes.pl, genere_ptool and ptools_core

* Wed Aug 21 2002 Erwan Velu <erwan@mandrakesoft.com> 2.0-5mdk
- Back to gcc 2.96
* Wed Aug 21 2002 Erwan Velu <erwan@mandrakesoft.com> 2.0-4mdk
- Rebuild
* Mon Aug 12 2002 Antoine Ginies <aginies@mandrakesoft.com> 2.0-3mdk
- build gcc 3.2
* Mon Jul 15 2002 Erwan Velu <erwan@mandrakesoft.com> 2.0-2mdk
- Fixing genere_ptool script
* Wed Jul 3 2002 Erwan Velu <erwan@mandrakesoft.com> 2.0-1mdk
- Mandrake Linux build
- Changing prefix to buildroot
* Tue Jul 2 2002 Wilfrid Billot <wilfrid.billot@imag.fr> 2.0-1
- Bugs fixed to compile with gcc3.0
